import { getLocation as n } from "./location.mjs";

function printLocation$1(t) {
  return printSourceLocation$1(t.source, n(t.source, t.start));
}

function printSourceLocation$1(n, t) {
  return n.name + ":" + (t.line + n.locationOffset.line - 1) + ":" + (t.column + t.line === 1 ? n.locationOffset.column - 1 : 0);
}

function printLocation(t) {
  return printSourceLocation(t.source, n(t.source, t.start));
}

function printSourceLocation(n, t) {
  var r = n.locationOffset.column - 1;
  var o = "".padStart(r) + n.body;
  var i = t.line - 1;
  var a = t.line + (n.locationOffset.line - 1);
  var e = t.column + (1 === t.line ? r : 0);
  var c = n.name + ":" + a + ":" + e + "\n";
  var u = o.split(/\r\n|[\n\r]/g);
  var p = u[i];
  if (p.length > 120) {
    var f = Math.floor(e / 80);
    var l = e % 80;
    var s = [];
    for (var L = 0; L < p.length; L += 80) {
      s.push(p.slice(L, L + 80));
    }
    return c + printPrefixedLines([ [ a + " |", s[0] ] ].concat(s.slice(1, f + 1).map((function(n) {
      return [ "|", n ];
    })), [ [ "|", "^".padStart(l) ] ], [ [ "|", s[f + 1] ] ]));
  }
  return c + printPrefixedLines([ [ a - 1 + " |", u[i - 1] ], [ a + " |", p ], [ "|", "^".padStart(e) ], [ a + 1 + " |", u[i + 1] ] ]);
}

function printPrefixedLines(n) {
  var t = n.filter((function(n) {
    return void 0 !== n[1];
  }));
  var r = Math.max.apply(Math, t.map((function(n) {
    return n[0].length;
  })));
  return t.map((function(n) {
    var t = n[1];
    return n[0].padStart(r) + (t ? " " + t : "");
  })).join("\n");
}

export { printLocation$1 as printLocation, printLocation as printLocation$1, printSourceLocation$1 as printSourceLocation, printSourceLocation as printSourceLocation$1 };
