"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var n = require("../jsutils/invariant.js");

var e = require("../language/printer.js");

var r = require("../language/blockString.js");

var t = require("../type/introspection.js");

var i = require("../type/directives.js");

var p = require("../type/definition.js");

var u = require("./astFromValue.js");

function printSchemaDefinition(n) {
  if (null == n.description && function isSchemaOfCommonNames(n) {
    var e = n.getQueryType();
    if (e && "Query" !== e.name) {
      return !1;
    }
    var r = n.getMutationType();
    if (r && "Mutation" !== r.name) {
      return !1;
    }
    var t = n.getSubscriptionType();
    if (t && "Subscription" !== t.name) {
      return !1;
    }
    return !0;
  }(n)) {
    return;
  }
  var e = [];
  var r = n.getQueryType();
  if (r) {
    e.push("  query: " + r.name);
  }
  var t = n.getMutationType();
  if (t) {
    e.push("  mutation: " + t.name);
  }
  var i = n.getSubscriptionType();
  if (i) {
    e.push("  subscription: " + i.name);
  }
  return printDescription(n) + "schema {\n" + e.join("\n") + "\n}";
}

function printImplementedInterfaces(n) {
  var e = n.getInterfaces();
  return e.length ? " implements " + e.map((function(n) {
    return n.name;
  })).join(" & ") : "";
}

function printFields(n) {
  return printBlock(Object.values(n.getFields()).map((function(n, e) {
    return printDescription(n, "  ", !e) + "  " + n.name + printArgs(n.args, "  ") + ": " + String(n.type) + printDeprecated(n.deprecationReason);
  })));
}

function printBlock(n) {
  return 0 !== n.length ? " {\n" + n.join("\n") + "\n}" : "";
}

function printArgs(n, e) {
  if (void 0 === e) {
    e = "";
  }
  if (0 === n.length) {
    return "";
  }
  if (n.every((function(n) {
    return !n.description;
  }))) {
    return "(" + n.map(printInputValue).join(", ") + ")";
  }
  return "(\n" + n.map((function(n, r) {
    return printDescription(n, "  " + e, !r) + "  " + e + printInputValue(n);
  })).join("\n") + "\n" + e + ")";
}

function printInputValue(n) {
  var r = u.astFromValue(n.defaultValue, n.type);
  var t = n.name + ": " + String(n.type);
  if (r) {
    t += " = " + e.print(r);
  }
  return t + printDeprecated(n.deprecationReason);
}

function printDeprecated(n) {
  if (null == n) {
    return "";
  }
  if (n !== i.DEFAULT_DEPRECATION_REASON) {
    return " @deprecated(reason: " + e.print({
      kind: "StringValue",
      value: n
    }) + ")";
  }
  return " @deprecated";
}

function printDescription(n, e, t) {
  if (void 0 === e) {
    e = "";
  }
  if (void 0 === t) {
    t = !0;
  }
  var i = n.description;
  if (null == i) {
    return "";
  }
  return (e && !t ? "\n" + e : e) + r.printBlockString(i).replace(/\n/g, "\n" + e) + "\n";
}

exports.printIntrospectionSchema = function printIntrospectionSchema(r) {
  return function printFilteredSchema(r, t, i) {
    var u = r.getDirectives().filter(t);
    var a = Object.values(r.getTypeMap()).filter(i);
    return [ printSchemaDefinition(r) ].concat(u.map((function(n) {
      return function printDirective(n) {
        return printDescription(n) + "directive @" + n.name + printArgs(n.args) + (n.isRepeatable ? " repeatable" : "") + " on " + n.locations.join(" | ");
      }(n);
    })), a.map((function(r) {
      return function printType(r) {
        if (p.isScalarType(r)) {
          return function printScalar(n) {
            return printDescription(n) + "scalar " + n.name + function printSpecifiedByURL(n) {
              if (null == n.specifiedByURL) {
                return "";
              }
              return " @specifiedBy(url: " + e.print({
                kind: "StringValue",
                value: n.specifiedByURL
              }) + ")";
            }(n);
          }(r);
        }
        if (p.isObjectType(r)) {
          return function printObject(n) {
            return printDescription(n) + "type " + n.name + printImplementedInterfaces(n) + printFields(n);
          }(r);
        }
        if (p.isInterfaceType(r)) {
          return function printInterface(n) {
            return printDescription(n) + "interface " + n.name + printImplementedInterfaces(n) + printFields(n);
          }(r);
        }
        if (p.isUnionType(r)) {
          return function printUnion(n) {
            var e = n.getTypes();
            var r = e.length ? " = " + e.join(" | ") : "";
            return printDescription(n) + "union " + n.name + r;
          }(r);
        }
        if (p.isEnumType(r)) {
          return function printEnum(n) {
            var e = n.getValues().map((function(n, e) {
              return printDescription(n, "  ", !e) + "  " + n.name + printDeprecated(n.deprecationReason);
            }));
            return printDescription(n) + "enum " + n.name + printBlock(e);
          }(r);
        }
        if (p.isInputObjectType(r)) {
          return function printInputObject(n) {
            var e = Object.values(n.getFields()).map((function(n, e) {
              return printDescription(n, "  ", !e) + "  " + printInputValue(n);
            }));
            return printDescription(n) + "input " + n.name + printBlock(e);
          }(r);
        }
        n.invariant(!1);
      }(r);
    }))).filter(Boolean).join("\n\n");
  }(r, i.isSpecifiedDirective, t.isIntrospectionType);
};
